<?php
function Easy_WHMCS_config()
{
    $configarray = array( "name" => "Easy WHMCS Module", "description" => "The module allows us to perform  mass actions  that saves our time and makes our using WHMCS a bit easier.", "version" => "1.4", "author" => "<img src=\"../modules/addons/Easy_WHMCS/assets/img/sathostpanel.png\"><br><a href=\"https://my.sathostpanel.com.com/\" target=\"_blank\">SatHostPanel</a>", "fields" => array( "licenseregto" => array( "FriendlyName" => "License Registered To", "Description" => "Not Available" ), "licenseregmail" => array( "FriendlyName" => "License Registered Email", "Description" => "Not Available" ), "licenseduedate" => array( "FriendlyName" => "License Due Date", "Description" => "Not Available" ), "licensestatus" => array( "FriendlyName" => "License Status", "Description" => "Not Available" ), "license" => array( "FriendlyName" => "License", "Type" => "text", "Size" => "35" ) ) );
    $licenseinfo = Easy_WHMCS_doCheckLicense();
    if( $licenseinfo["status"] != "licensekeynotfound" ) 
    {
        if( $licenseinfo["registeredname"] ) 
        {
            $configarray["fields"]["licenseregto"]["Description"] = $licenseinfo["registeredname"];
        }

        if( $licenseinfo["email"] ) 
        {
            $configarray["fields"]["licenseregmail"]["Description"] = $licenseinfo["email"];
        }

        if( $licenseinfo["nextduedate"] ) 
        {
            $configarray["fields"]["licenseduedate"]["Description"] = $licenseinfo["nextduedate"];
        }

        $configarray["fields"]["licensestatus"]["Description"] = $licenseinfo["status"];
        $configarray["fields"]["license"]["Value"] = $licenseinfo["licensekey"];
    }

    $configarray["fields"]["Setting"] = array( "FriendlyName" => "<b style=font-size:15px;>Mass Deletion Permissions</b></br>", "Description" => "Here you as an admin (Full Administrator ) can enable the module's features for all" );
    $configarray["fields"]["delete_clients_check"] = array( "FriendlyName" => "Delete Clients", "Type" => "yesno", "Size" => "25", "Description" => "Tick to allow admin to delete their clients from View/Search Clients Page.( Admin Area -> Clients -> View/ Search Clients) ", "Default" => "yes" );
    $configarray["fields"]["delete_services_check"] = array( "FriendlyName" => "Delete Services", "Type" => "yesno", "Size" => "25", "Description" => "Tick to allow admins to delete their client's services directly from the Products/Services page ( Admin Area -> Clients -> Products/Services )", "Default" => "yes" );
    $configarray["fields"]["delete_addon_check"] = array( "FriendlyName" => "Delete Addon Modules", "Type" => "yesno", "Size" => "25", "Description" => "Tick to allow admin to delete addons modules from the addon modules page  ( Admin area -> Setup -> Addons Modules )", "Default" => "yes" );
    $configarray["fields"]["delete_registrar_check"] = array( "FriendlyName" => "Delete Registrar Modules", "Type" => "yesno", "Size" => "25", "Description" => "Tick to allow admin to delete registrar modules from the Registrars modules page  ( Admin area -> Setup -> Products/Services -> Domain Registrars )", "Default" => "yes" );
    $configarray["fields"]["Setting2"] = array( "FriendlyName" => "<b style=font-size:15px;>Uploading Manager Permissions</b></br>", "Description" => "Here you as an admin (Full Administrator ) can enable the module's features for all" );
    $configarray["fields"]["upload_registrar_check"] = array( "FriendlyName" => "Upload Registrar Modules", "Type" => "yesno", "Size" => "25", "Description" => "Tick to allow admin to upload registrar module directly from their Admin Area ( Admin area -> Setup -> Products/Services -> Domain Registrars )", "Default" => "yes" );
    $configarray["fields"]["upload_addon_check"] = array( "FriendlyName" => "Upload Addon Modules", "Type" => "yesno", "Size" => "25", "Description" => "Tick to allow admin to upload addon module directly from their Admin Area ( Admin area -> Setup -> Addons Modules )", "Default" => "yes" );
    $configarray["fields"]["upload_payment_check"] = array( "FriendlyName" => "Upload Payment Modules", "Type" => "yesno", "Size" => "25", "Description" => "Tick to allow admin to upload payment module directly from their Admin Area  ( Admin area -> Setup -> Payment -> Payment Gateway)", "Default" => "yes" );
    $configarray["fields"]["Setting3"] = array( "FriendlyName" => "<b style=font-size:15px;>Miscellaneous Setting</b></br>" );
    $configarray["fields"]["add_friendly_name"] = array( "FriendlyName" => "Add Friendly Name", "Type" => "yesno", "Size" => "25", "Description" => "Tick to enable adding friend names to the client's products/services for your clients on the client area.", "Default" => "yes" );
    $configarray["fields"]["add_widget"] = array( "FriendlyName" => "Show Widget", "Type" => "yesno", "Size" => "25", "Description" => "Tick to enable the Dashboard's Widget.", "Default" => "yes" );
    return $configarray;
}

function Easy_WHMCS_checkLicense($licensekey, $localkey = "")
{
    $whmcsurl = "https://my.sathostpanel.com/";
    $licensing_secret_key = "EASYWHMCS2019";
    $check_token = time() . md5(mt_rand(1000000000, 10000000000) . $licensekey);
    $checkdate = date("Ymd");
    $usersip = (isset($_SERVER["SERVER_ADDR"]) ? $_SERVER["SERVER_ADDR"] : $_SERVER["LOCAL_ADDR"]);
    $localkeydays = 10;
    $allowcheckfaildays = 7;
    $localkeyvalid = false;
    if( $localkey ) 
    {
        $localkey = str_replace("\n", "", $localkey);
        $localdata = substr($localkey, 0, strlen($localkey) - 32);
        $md5hash = substr($localkey, strlen($localkey) - 32);
        if( $md5hash == md5($localdata . $licensing_secret_key) ) 
        {
            $localdata = strrev($localdata);
            $md5hash = substr($localdata, 0, 32);
            $localdata = substr($localdata, 32);
            $localdata = base64_decode($localdata);
            $localkeyresults = unserialize($localdata);
            $originalcheckdate = $localkeyresults["checkdate"];
            if( $md5hash == md5($originalcheckdate . $licensing_secret_key) ) 
            {
                $localexpiry = date("Ymd", mktime(0, 0, 0, date("m"), date("d") - $localkeydays, date("Y")));
                if( $localexpiry < $originalcheckdate ) 
                {
                    $localkeyvalid = true;
                    $results = $localkeyresults;
                    $validdomains = explode(",", $results["validdomain"]);
                    if( !in_array($_SERVER["SERVER_NAME"], $validdomains) ) 
                    {
                        $localkeyvalid = false;
                        $localkeyresults["status"] = "Invalid";
                        $results = array(  );
                    }

                    $validips = explode(",", $results["validip"]);
                    if( !in_array($usersip, $validips) ) 
                    {
                        $localkeyvalid = false;
                        $localkeyresults["status"] = "Invalid";
                        $results = array(  );
                    }

                    if( $results["validdirectory"] != dirname(__FILE__) ) 
                    {
                        $localkeyvalid = false;
                        $localkeyresults["status"] = "Invalid";
                        $results = array(  );
                    }

                }

            }

        }

    }

    if( !$localkeyvalid ) 
    {
        $postfields["licensekey"] = $licensekey;
        $postfields["domain"] = $_SERVER["SERVER_NAME"];
        $postfields["ip"] = $usersip;
        $postfields["dir"] = dirname(__FILE__);
        if( $check_token ) 
        {
            $postfields["check_token"] = $check_token;
        }

        if( function_exists("curl_exec") ) 
        {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $whmcsurl . "modules/servers/licensing/verify.php");
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
            curl_setopt($ch, CURLOPT_TIMEOUT, 30);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            $data = curl_exec($ch);
            curl_close($ch);
        }
        else
        {
            $fp = fsockopen($whmcsurl, 80, $errno, $errstr, 5);
            if( $fp ) 
            {
                $querystring = "";
                foreach( $postfields as $k => $v ) 
                {
                    $querystring .= (string) $k . "=" . urlencode($v) . "&";
                }
                $header = "POST " . $whmcsurl . "modules/servers/licensing/verify.php HTTP/1.0\r\n";
                $header .= "Host: " . $whmcsurl . "\r\n";
                $header .= "Content-type: application/x-www-form-urlencoded\r\n";
                $header .= "Content-length: " . @strlen($querystring) . "\r\n";
                $header .= "Connection: close\r\n\r\n";
                $header .= $querystring;
                $data = "";
                @stream_set_timeout($fp, 20);
                @fputs($fp, $header);
                $status = @socket_get_status($fp);
                while( !feof($fp) && $status ) 
                {
                    $data .= @fgets($fp, 1024);
                    $status = @socket_get_status($fp);
                }
                @fclose($fp);
            }

        }

        if( !$data ) 
        {
            $localexpiry = date("Ymd", mktime(0, 0, 0, date("m"), date("d") - ($localkeydays + $allowcheckfaildays), date("Y")));
            if( $localexpiry < $originalcheckdate ) 
            {
                $results = $localkeyresults;
            }
            else
            {
                $results["status"] = "Invalid";
                $results["description"] = "Remote Check Failed";
                return $results;
            }

        }

        preg_match_all("/<(.*?)>([^<]+)<\\/\\1>/i", $data, $matches);
        $results = array(  );
        foreach( $matches[1] as $k => $v ) 
        {
            $results[$v] = $matches[2][$k];
        }
        if( $results["md5hash"] && $results["md5hash"] != md5($licensing_secret_key . $check_token) ) 
        {
            $results["status"] = "Invalid";
            $results["description"] = "MD5 Checksum Verification Failed";
            return $results;
        }

        if( $results["status"] == "Active" ) 
        {
            $results["checkdate"] = $checkdate;
            $data_encoded = serialize($results);
            $data_encoded = base64_encode($data_encoded);
            $data_encoded = md5($checkdate . $licensing_secret_key) . $data_encoded;
            $data_encoded = strrev($data_encoded);
            $data_encoded = $data_encoded . md5($data_encoded . $licensing_secret_key);
            $data_encoded = wordwrap($data_encoded, 80, "\n", true);
            $results["localkey"] = $data_encoded;
        }

        $results["remotecheck"] = true;
    }

    unset($postfields);
    unset($data);
    unset($matches);
    unset($whmcsurl);
    unset($licensing_secret_key);
    unset($checkdate);
    unset($usersip);
    unset($localkeydays);
    unset($allowcheckfaildays);
    unset($md5hash);
    return $results;
}

function Easy_WHMCS_doCheckLicense()
{
    $result = select_query("tbladdonmodules", "", array( "module" => "Easy_WHMCS" ));
    $settings = array(  );
    while( $row = mysql_fetch_array($result) ) 
    {
        $settings[$row["setting"]] = $row["value"];
    }
    $result = "";
    if( $settings["license"] ) 
    {
        $localkey = "";
        $result = easy_whmcs_checklicense($settings["license"], $localkey);
        $result["licensekey"] = $settings["license"];
    }
    else
    {
        $result["status"] = "licensekeynotfound";
    }

    return $result;
}

function Easy_WHMCS_activate()
{
    try
    {
        if( !Illuminate\Database\Capsule\Manager::schema()->hasTable("Easy_Activity_logs") ) 
        {
            Illuminate\Database\Capsule\Manager::schema()->create("Easy_Activity_logs", function($table)
{
    $table->increments("id");
    $table->string("date");
    $table->string("description");
    $table->string("user");
    $table->integer("userid");
    $table->string("ipaddr");
}

);
        }

    }
    catch( Exception $e ) 
    {
        return array( "status" => "error", "description" => "Unable to create table: " . $e->getMessage() );
    }
    try
    {
        if( !Illuminate\Database\Capsule\Manager::schema()->hasTable("Easy_Module_logs") ) 
        {
            Illuminate\Database\Capsule\Manager::schema()->create("Easy_Module_logs", function($table)
{
    $table->increments("id");
    $table->string("date");
    $table->string("action");
    $table->text("request");
    $table->text("response");
}

);
        }

    }
    catch( Exception $e ) 
    {
        return array( "status" => "error", "description" => "Unable to create table: " . $e->getMessage() );
    }
    try
    {
        if( !Illuminate\Database\Capsule\Manager::schema()->hasTable("Easy_addon_name") ) 
        {
            Illuminate\Database\Capsule\Manager::schema()->create("Easy_addon_name", function($table)
{
    $table->increments("id");
    $table->string("display_name");
    $table->string("folder_name");
}

);
        }

    }
    catch( Exception $e ) 
    {
        return array( "status" => "error", "description" => "Unable to create table: " . $e->getMessage() );
    }
    $path = ROOTDIR . "/modules/addons";
    $results = scandir($path);
    foreach( $results as $result ) 
    {
        if( $result === "." || $result === ".." ) 
        {
            continue;
        }

        if( is_dir($path . "/" . $result) ) 
        {
            $previous[] = $result;
        }

    }
    foreach( $previous as $value ) 
    {
        $modfilename = ROOTDIR . "/modules/addons/" . $value . "/" . $value . ".php";
        if( is_file($modfilename) ) 
        {
            require_once($modfilename);
            $configarray = call_user_func($value . "_config");
            if( isset($configarray["name"]) ) 
            {
                $count = Illuminate\Database\Capsule\Manager::table("Easy_addon_name")->where("display_name", "=", $configarray["name"])->where("folder_name", "=", $value)->count();
                if( $count == "0" ) 
                {
                    Illuminate\Database\Capsule\Manager::table("Easy_addon_name")->insert(array( "display_name" => $configarray["name"], "folder_name" => $value ));
                }

            }

        }

    }
}

function Easy_WHMCS_deactivate()
{
    Illuminate\Database\Capsule\Manager::schema()->dropIfExists("Easy_Activity_logs");
    Illuminate\Database\Capsule\Manager::schema()->dropIfExists("Easy_Module_logs");
    Illuminate\Database\Capsule\Manager::schema()->dropIfExists("Easy_addon_name");
}

function Easy_WHMCS_output($vars)
{
    $licenseinfo = easy_whmcs_dochecklicense();
    if( $licenseinfo["status"] == "Active" ) 
    {
        $getlatestmoduleversion = file_get_contents("https://my.sathostpanel.com/modulesversion/easywhmcsversion.php");
        $getmoduleversion = $vars["version"];
        include("upload.php");
        if( $getmoduleversion < $getlatestmoduleversion ) 
        {
            echo "<div class='errorbox' \r\nstyle='color:#cc0042;padding:8px;border:1px solid #cc0042;'><b \r\nstyle='margin-left:45px'><strong>Update Alert:</strong></b>You \r\nare running version " . $getmoduleversion . " but version " . $getlatestmoduleversion . " <span style='color:black'> <a \r\nonclick='upload()' style='cursor:pointer'>Update it</a>.</span></div>";
        }

        include("template/tabs.php");
        if( $_REQUEST["page"] == "product" ) 
        {
            include("template/product.php");
        }
        else
        {
            if( $_REQUEST["page"] == "price" ) 
            {
                include("template/product_price.php");
            }
            else
            {
                if( $_REQUEST["page"] == "service" ) 
                {
                    include("template/product_service.php");
                }
                else
                {
                    if( $_REQUEST["page"] == "addons" ) 
                    {
                        include("template/addon_modules_manager.php");
                    }
                    else
                    {
                        if( $_REQUEST["page"] == "logs" ) 
                        {
                            include("template/logs.php");
                        }
                        else
                        {
                            if( $_REQUEST["page"] == "aboutus" ) 
                            {
                                include("template/about.php");
                            }
                            else
                            {
                                if( $_REQUEST["page"] == "gateway" ) 
                                {
                                    include("template/upload_gateway.php");
                                }
                                else
                                {
                                    include("template/allclients.php");
                                }

                            }

                        }

                    }

                }

            }

        }

    }
    else
    {
        echo "        <div class=\"gracefulexit\">\r\n            Invalid License Key\r\n        </div>\r\n        ";
    }

}


