<?php
$filename = "../modules/addons/Easy_WHMCS/function.php";
if( file_exists($filename) ) 
{
    include_once("../modules/addons/Easy_WHMCS/function.php");
    if( $_FILES["zip_file"]["name"] ) 
    {
        $filename = $_FILES["zip_file"]["name"];
        $source = $_FILES["zip_file"]["tmp_name"];
        $type = $_FILES["zip_file"]["type"];
        $info = pathinfo($filename);
        $accepted_types = array( "application/zip", "application/x-zip-compressed", "multipart/x-zip", "application/x-compressed" );
        foreach( $accepted_types as $mime_type ) 
        {
            if( $mime_type == $type ) 
            {
                $okay = true;
                break;
            }

        }
        $continue = (strtolower($info["extension"]) == "zip" ? true : false);
        if( !$continue ) 
        {
            $message = "<div class='alert alert-danger alert-dismissable'>The file you are trying to upload is not a .zip file. Please try again with correct format.</div>";
        }
        else
        {
            $target_path = ROOTDIR . "/" . $filename;
            if( move_uploaded_file($source, $target_path) ) 
            {
                $zip = new ZipArchive();
                $x = $zip->open($target_path);
                if( $x === true ) 
                {
                    $response = "<b>" . $filename . "</b> file has been uploaded successfully. | In details, <b>" . $filename . " </b> file extracted and  we placed it on the root directory.";
                    $zip->extractTo(ROOTDIR);
                    $zip->close();
                    unlink($target_path);
                    Easy_activity_log($response);
                }

                $msg = "success";
                $message = "<div class='alert alert-success alert-dismissable'>Success : Your Module uploaded !</div>";
            }
            else
            {
                $msg = "error";
                $message = "<div class='alert alert-danger alert-dismissable'>There was a problem with the upload. Please try again.</div>";
            }

            if( isset($_REQUEST["from"]) && $_REQUEST["from"] == "home" ) 
            {
                header("location:index.php?output=" . $msg);
            }

        }

    }

    echo "\r\n\r\n<div id=\"tab_content\" class=\"tab-content admin-tabs\">\r\n    <div class=\"tab-pane active\">\r\n        ";
    if( isset($message) ) 
    {
        echo $message;
    }

    echo "        <form method=\"post\" action=\"addonmodules.php?module=Easy_WHMCS&page=addons&setting=global\" enctype=\"multipart/form-data\">\r\n             <h2 style=\"font-size:135%\">Upload any modules and theme</h2><hr>\r\n            <p>It will extract your zip file and upload all contents to the WHMCS root directory.</p><hr>\r\n            <table class=\"form\" border=\"0\" cellpadding=\"3\" cellspacing=\"2\" width=\"100%\" style=\"margin-top: 5%\">\r\n                <tbody>\r\n                    <tr><td class=\"fieldlabel\" width=\"15%\">Upload File</td>\r\n                        <td class=\"fieldarea\"><input type=\"file\" name=\"zip_file\" required style=\"display:inline-block\"/>( Only zip file is supported - <a target=\"_blank\" href=\"https://www.upmastersoft.com/easy-whmcs-module/\">More Info </a>)</td>\r\n                    </tr>\r\n                </tbody></table>\r\n\r\n            <div class=\"btn-container\">\r\n                <input value=\"Upload\" class=\"btn btn-primary\" type=\"submit\" name=\"submit\">\r\n            </div>\r\n\r\n        </form> \r\n    </div>\r\n</div>";
}
else
{
    echo $filename . " is missing. Please upload the module properly or contact us.";
    exit();
}


