<?php
$filename = "../modules/addons/Easy_WHMCS/function.php";
if( file_exists($filename) ) 
{
    include_once("../modules/addons/Easy_WHMCS/function.php");
    if( $_FILES["zip_file"]["name"] ) 
    {
        $filename = $_FILES["zip_file"]["name"];
        $source = $_FILES["zip_file"]["tmp_name"];
        $type = $_FILES["zip_file"]["type"];
        $info = pathinfo($filename);
        $accepted_types = array( "application/zip", "application/x-zip-compressed", "multipart/x-zip", "application/x-compressed" );
        foreach( $accepted_types as $mime_type ) 
        {
            if( $mime_type == $type ) 
            {
                $okay = true;
                break;
            }

        }
        $continue = (strtolower($info["extension"]) == "zip" ? true : false);
        if( !$continue ) 
        {
            $out = "1";
            $message = "<div class='alert alert-danger alert-dismissable'>The file you are trying to upload is not a .zip file. Please try again with correct format.</div>";
        }
        else
        {
            $target_path = ROOTDIR . "/modules/addons/" . $filename;
            if( move_uploaded_file($source, $target_path) ) 
            {
                $zip = new ZipArchive();
                $x = $zip->open($target_path);
                if( $x === true ) 
                {
                    for( $i = 0; $i < $zip->numFiles; $i++ ) 
                    {
                        $file = $zip->getNameIndex($i);
                        $arr = explode("/", $file);
                        $content[] = $arr[0];
                    }
                    if( in_array("modules", $content) ) 
                    {
                        $response = "<b>" . $filename . "</b> file has been uploaded successfully. | In details, <b>" . $filename . " </b> file extracted and found 'modules' folder and we placed it on the root directory.";
                        $zip->extractTo(ROOTDIR);
                    }
                    else
                    {
                        $response = "<b>" . $filename . "</b> file has been uploaded successfully. | In details,<b>" . $filename . " </b> file extracted and found " . $folder . " folder and placed it in modules/addons.";
                        $zip->extractTo(ROOTDIR . "/modules/addons/");
                    }

                    Easy_activity_log($response);
                    $zip->close();
                    unlink($target_path);
                }

                $out = "2";
                $message = "<div class='alert alert-success alert-dismissable'>Success : Your Module uploaded !</div>";
            }
            else
            {
                $out = "3";
                $message = "<div class='alert alert-danger alert-dismissable'>There was a problem with the upload. Please try again.</div>";
            }

        }

        if( isset($_REQUEST["from"]) && $_REQUEST["from"] == "config" ) 
        {
            header("location:configaddonmods.php?output=" . $out);
        }

    }

    if( isset($_REQUEST["action"]) && $_REQUEST["action"] == "singledelete" ) 
    {
        if( isset($_REQUEST["from"]) && $_REQUEST["from"] == "home" ) 
        {
            $str2 = trim(substr($_REQUEST["addonid"], 4));
            $value = Illuminate\Database\Capsule\Manager::table("Easy_addon_name")->where("display_name", "=", $str2)->get();
            $addon_name = trim($value[0]->folder_name);
        }
        else
        {
            $addon_name = trim($_REQUEST["value"]);
        }

        if( is_dir(ROOTDIR . "/modules/addons/") && $addon_name != "" ) 
        {
            $dir = ROOTDIR . "/modules/addons/" . $addon_name;
            if( is_dir($dir) ) 
            {
                $req = "   while(false !== ( " . $file . " = readdir(" . $dir . ")) ) {\r\n\t\t\r\n        if (( " . $file . " != '.' ) && ( " . $file . " != '..' )) {\r\n            " . $full . " = " . $src . " . '/' . " . $file . ";\r\n            if ( is_dir(" . $full . ") ) {\r\n                easy_delete_modules(" . $full . ");\r\n            }\r\n            else {\r\n                unlink(" . $full . ");\r\n            }\r\n        }\r\n    }\r\n\r\n    closedir(" . $dir . ");\r\n    " . $res . "=rmdir(" . $src . ");";
                $resp = easy_delete_modules($dir);
                if( $resp == "1" ) 
                {
                    $msg = "success";
                    $response = "Module named <b> " . $addon_name . "</b> module deleted successfully!";
                }
                else
                {
                    $msg = "error_permission";
                    $response = "Module named </b>" . $addon_name . "</b> can not deleted.";
                }

            }
            else
            {
                $msg = "error";
                $response = "The module you are going  to delete is not found.";
            }

            Easy_activity_log($response);
            Easy_Module_logs("deleteaddon", $req, $resp);
            if( isset($_REQUEST["from"]) && $_REQUEST["from"] == "home" ) 
            {
                header("location:configaddonmods.php?output=" . $msg);
            }

        }

    }

    global $CONFIG;
    $activemodules = explode(",", $CONFIG["ActiveAddonModules"]);
    $path = ROOTDIR . "/modules/addons";
    $results = scandir($path);
    foreach( $results as $result ) 
    {
        if( $result === "." || $result === ".." ) 
        {
            continue;
        }

        if( is_dir($path . "/" . $result) ) 
        {
            $previous[] = $result;
        }

    }
    echo "\r\n<div id=\"tab_content\" class=\"tab-content admin-tabs\">\r\n    <div class=\"tab-pane active\">\r\n        ";
    if( $message ) 
    {
        echo "<p>" . $message . "</p>";
    }

    echo "        ";
    if( isset($msg) && ($msg == "success" || $msg == "error") ) 
    {
        echo "            <div class=\"alert alert-success alert-dismissable\">\r\n                <a href=\"#\" class=\"close\" data-dismiss=\"alert\" aria-label=\"close\">&times;</a>\r\n                ";
        if( $msg == "success" ) 
        {
            echo "Success : Your module Deleted !";
        }
        else
        {
            echo "No Module found to delete";
        }

        echo "  \r\n            </div> \r\n        ";
    }

    echo "        <form method=\"post\" action=\"addonmodules.php?module=Easy_WHMCS&page=addons\" enctype=\"multipart/form-data\">\r\n            <h2 style=\"font-size:135%\">Upload your addon module</h2><hr>\r\n            <p style=\"line-height: 30px\">Here you can upload your add-ons module directly.It allows only zip files to be uploaded ( .zip extension ).It support two type of File structure.<br><b>Format and file Structure Supported:</b>\r\n                <br>\r\n                <b> 1)</b> <b> &lt;your-zip-file&gt; </b>&rarr; modules &rarr; addons &rarr; <b>&lt;your-modulename-folder&gt;</b>.    ( Example : Easy_whmcs.zip &rarr; modules &rarr; addnos &rarr; Easy_whmcs ).<br>\r\n                <b> 2)</b> <b>&lt;your-zip-file&gt;</b> &rarr; <b>&lt;your-modulename-folder&gt;</b>. ( Example : Easy_whmcs.zip &rarr; Easy_whmcs )\r\n            </p><hr>\r\n            <table class=\"form\" border=\"0\" cellpadding=\"3\" cellspacing=\"2\" width=\"100%\" style=\"margin-top: 5%\">\r\n                <tbody>\r\n                    <tr><td class=\"fieldlabel\" width=\"15%\">Upload File</td>\r\n                        <td class=\"fieldarea\"><input type=\"file\" name=\"zip_file\" required style=\"display:inline-block\"/>( Only zip file is supported - <a target=\"_blank\" href=\"https://www.upmastersoft.com/easy-whmcs-module/\">More Info </a>)</td>\r\n                    </tr>\r\n                </tbody></table>\r\n\r\n            <div class=\"btn-container\">\r\n                <input value=\"Upload\" class=\"btn btn-primary\" type=\"submit\" name=\"submit\">\r\n            </div>\r\n        </form>\r\n        <form method=\"post\" action=\"\" style=\"margin-top: 3%\">\r\n            <input name=\"token\" value=\"7932554c37ead925ea86937e0ff0e8c0ba407f5d\" type=\"hidden\">\r\n            <input name=\"action\" value=\"save\" type=\"hidden\">\r\n\r\n            <div class=\"tablebg\">\r\n                <table class=\"datatable\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\" width=\"100%\">\r\n                    <tbody>\r\n                        <tr>\r\n                            <th>Module</th>\r\n                            <th width='100'>Version</th>\r\n                            <th width='100'>Author</th>\r\n                            <th width='100'>Status</th>\r\n                            <th width='100'>Action</th>\r\n                        </tr>\r\n                        ";
    foreach( $previous as $value ) 
    {
        $modfilename = ROOTDIR . "/modules/addons/" . $value . "/" . $value . ".php";
        if( is_file($modfilename) ) 
        {
            require_once($modfilename);
            $configarray = call_user_func($value . "_config");
            if( isset($configarray["name"]) ) 
            {
                $count = Illuminate\Database\Capsule\Manager::table("Easy_addon_name")->where("display_name", "=", $configarray["name"])->where("folder_name", "=", $value)->count();
                if( $count == "0" ) 
                {
                    Illuminate\Database\Capsule\Manager::table("Easy_addon_name")->insert(array( "display_name" => $configarray["name"], "folder_name" => $value ));
                }

                echo "                                    <tr>\r\n                                        <td>";
                echo "<img src='../modules/addons/Easy_WHMCS/assets/img/arrow-right.png' height=8px width=8px><b style='font-weight:700'> " . $configarray["name"];
                echo "</b>\r\n                                            ";
                echo "<br />" . $configarray["description"];
                echo "</td>\r\n                                        <td align=\"center\">";
                echo $configarray["version"];
                echo "</td> \r\n                                        <td> ";
                echo "<br />" . $configarray["author"];
                echo "</td>\r\n                                        <td align=\"center\">";
                if( in_array($value, $activemodules) ) 
                {
                    echo "<b style='color:Green'>Active</b>";
                }
                else
                {
                    echo "<b style='color:red'>Deactive</b>";
                }

                echo "</td>\r\n                                        ";
                if( in_array($value, $activemodules) ) 
                {
                    echo "                                            <td><a onclick=\"return alert('you can not delete an active module.');\"  ><button type=\"button\" class=\"btn btn-danger\"><i class=\"fa fa-trash\" aria-hidden=\"true\"></i> Delete</button></a></td>\r\n                                        ";
                }
                else
                {
                    echo "                                            <td><a onclick=\"return confirm('Are you sure want to delete it ? \\n Note : It will delete the module folder and their files.');\" href=\"addonmodules.php?module=Easy_WHMCS&page=addons&action=singledelete&value=";
                    echo $value;
                    echo "\" ><button type=\"button\" class=\"btn btn-danger\"><i class=\"fa fa-trash\" aria-hidden=\"true\"></i> Delete</button></a></td>\r\n\r\n                                        ";
                }

                echo "                                    </tr>\r\n                                ";
            }

        }

    }
    echo "                    </tbody>\r\n                </table>\r\n            </div>\r\n\r\n        </form>\r\n    </div>\r\n</div>\r\n";
}
else
{
    echo $filename . " is missing. Please upload the module properly or contact us.";
    exit();
}


