<?php
$filename = "../modules/addons/Easy_WHMCS/function.php";
if( file_exists($filename) ) 
{
    include_once("../modules/addons/Easy_WHMCS/function.php");
    $all = Illuminate\Database\Capsule\Manager::table("tblproducts")->join("tblproductgroups", "tblproductgroups.id", "=", "tblproducts.gid")->select("tblproducts.id", "tblproducts.name", "tblproducts.type", "tblproducts.servertype", "tblproducts.paytype", "tblproducts.gid", "tblproductgroups.name as gname")->orderBy("tblproducts.gid", "asc")->get();
    if( isset($_REQUEST["log_limit"]) && !empty($_REQUEST["log_limit"]) ) 
    {
        $limitnum = $_REQUEST["log_limit"];
    }
    else
    {
        $limitnum = 10;
    }

    if( isset($_REQUEST["pageno"]) ) 
    {
        $nextPage = $_REQUEST["pageno"] + 1;
        $currentPage = $_REQUEST["pageno"];
        $previousPage = $_REQUEST["pageno"] - 1;
        if( $_REQUEST["pageno"] != 1 ) 
        {
            $limitstart = $_REQUEST["pageno"] * $limitnum - $limitnum;
        }
        else
        {
            $limitstart = 0;
        }

    }
    else
    {
        $currentPage = 1;
        $nextPage = 2;
        $limitstart = 0;
    }

    $totalRecords = count($all);
    $totalPage = ceil($totalRecords / $limitnum);
    if( isset($_GET["action"]) && $_GET["action"] == "edit_price" ) 
    {
        $num = $_POST["number"];
        for( $i = 1; $i <= $num; $i++ ) 
        {
            $c = count($_POST["currency" . $i]["msetupfee"]);
            for( $j = 0; $j < $c; $j++ ) 
            {
                $pid = $_POST["pid"][$j];
                $msetup = $_POST["currency" . $i]["msetupfee"][$j];
                $qsetup = $_POST["currency" . $i]["qsetupfee"][$j];
                $ssetup = $_POST["currency" . $i]["ssetupfee"][$j];
                $asetup = $_POST["currency" . $i]["asetupfee"][$j];
                $bsetup = $_POST["currency" . $i]["bsetupfee"][$j];
                $tsetup = $_POST["currency" . $i]["tsetupfee"][$j];
                $month = $_POST["currency" . $i]["monthly"][$j];
                $quarter = $_POST["currency" . $i]["quarterly"][$j];
                $semi = $_POST["currency" . $i]["semiannually"][$j];
                $annually = $_POST["currency" . $i]["annually"][$j];
                $bie = $_POST["currency" . $i]["biennially"][$j];
                $tri = $_POST["currency" . $i]["triennially"][$j];
                $curr1 = Illuminate\Database\Capsule\Manager::table("tblpricing")->where("relid", "=", $_POST["pid"][$j])->where("currency", "=", $i)->where("type", "=", "product")->get();
                $count = count($curr1);
                if( $count == "0" ) 
                {
                    $insert_array = array( "msetupfee" => $msetup, "qsetupfee" => $qsetup, "ssetupfee" => $ssetup, "asetupfee" => $asetup, "bsetupfee" => $bsetup, "tsetupfee" => $tsetup, "monthly" => $month, "quarterly" => $quarter, "semiannually" => $semi, "annually" => $annually, "biennially" => $bie, "triennially" => $tri, "type" => "product", "currency" => $i, "relid" => $pid );
                    Illuminate\Database\Capsule\Manager::table("tblpricing")->insert($insert_array);
                }
                else
                {
                    try
                    {
                        $update_array = array( "msetupfee" => $msetup, "qsetupfee" => $qsetup, "ssetupfee" => $ssetup, "asetupfee" => $asetup, "bsetupfee" => $bsetup, "tsetupfee" => $tsetup, "monthly" => $month, "quarterly" => $quarter, "semiannually" => $semi, "annually" => $annually, "biennially" => $bie, "triennially" => $tri );
                        $a = json_encode($update_array);
                        $request[$i][] = " Capsule::table('tblpricing')\r\n   ->where('relid', '=', " . $pid . ")\r\n   ->where('currency', '=', " . $i . ")\r\n  ->where('type', '=', 'product')\r\n   ->update(" . $a . ")";
                        $upd = Illuminate\Database\Capsule\Manager::table("tblpricing")->where("relid", "=", $_POST["pid"][$j])->where("currency", "=", $i)->where("type", "=", "product")->update($update_array);
                        $res[$i][] = $upd;
                    }
                    catch( Exception $e ) 
                    {
                        $response = $e->getMessage();
                    }
                    if( $upd == "0" ) 
                    {
                        Illuminate\Database\Capsule\Manager::table("tblproducts")->where("id", "=", $_POST["pid"][$j])->update(array( "paytype" => $_POST["pay" . $pid] ));
                        $response = "success";
                        $sid[$_POST["pid"][$j]] = "#" . $_POST["pid"][$j];
                        $msg = "success";
                    }

                }

            }
            Easy_Module_logs("editproductprice", json_encode($request[$i]), json_encode($res[$i]));
        }
        if( count($sid) != "0" ) 
        {
            $fg = implode(",", $sid);
            $response = "Products(s) " . $fg . " price updated successfully.";
            Easy_activity_log($response);
        }

        if( count($fid) != "0" ) 
        {
            $fg = implode(",", $fid);
            $response = "Products(s) " . $fg . " price can't updated.";
            Easy_activity_log($response);
        }

    }

    echo "<script>\r\n\r\n    function func(id)\r\n    {\r\n        var a = \$('input[name=pay' + id + ']:checked').val();\r\n        if (a === \"free\")\r\n        {\r\n            \$(\"#table\" + id).fadeOut();\r\n            \$(\"#trprice\" + id).hide();\r\n        }\r\n        if (a === \"onetime\")\r\n        {\r\n            \$(\"#table\" + id).css(\"max-width\", \"370px\");\r\n            \$(\"#table\" + id).css(\"margin-left\", \"29%\");\r\n            \$('.prod-pricing-recurring' + id).hide();\r\n        }\r\n        var u = \"mydiv\" + id;\r\n        if (\$(\"#\" + u).css('display') === 'none') {\r\n            document.getElementById(u).style.display = \"block\";\r\n            \$('#arrow' + id).attr('src', '../modules/addons/Easy_WHMCS/include/up.png');\r\n        }\r\n        else\r\n        {\r\n            document.getElementById(u).style.display = \"none\";\r\n            \$('#arrow' + id).attr('src', '../modules/addons/Easy_WHMCS/include/down.png');\r\n        }\r\n    }\r\n</script>\r\n<script>\r\n    \$(document).ready(function() {\r\n        \$('input.jas[type=text]').each(function() {\r\n            var val = \$(this).val();\r\n            var cycle = \$(this).attr(\"id\");\r\n            var arr = cycle.split('_');\r\n            var c = arr['2'];\r\n            var cur = arr['1'];\r\n            var pid = arr['3'];\r\n            if (val !== \"-1.00\" && val !== \"\")\r\n            {\r\n                \$('input:checkbox[cycle=\"' + c + '\"][currency=\"' + cur + '\"][product=\"' + pid + '\"]')\r\n                        .attr('checked', 'checked');\r\n            }\r\n\r\n\r\n        });\r\n//set initial state.\r\n        \$(\".pricingtgl\").click(function() {\r\n            var cycle = \$(this).attr(\"cycle\");\r\n            var currency = \$(this).attr(\"currency\");\r\n            var product = \$(this).attr(\"product\");\r\n\r\n            if (\$(this).is(\":checked\")) {\r\n                \$(\"#pricing_\" + currency + \"_\" + cycle + \"_\" + product).val(\"0.00\").show();\r\n\r\n                \$(\"#setup_\" + currency + \"_\" + cycle + \"_\" + product).show();\r\n            } else {\r\n                \$(\"#pricing_\" + currency + \"_\" + cycle + \"_\" + product).val(\"-1.00\").hide();\r\n                \$(\"#setup_\" + currency + \"_\" + cycle + \"_\" + product).val(\"0.00\").hide();\r\n            }\r\n        });\r\n\r\n\r\n        \$(\"input:checkbox:not(:checked)\").each(function() {\r\n            var cycle = \$(this).attr(\"cycle\");\r\n            var currency = \$(this).attr(\"currency\");\r\n            var product = \$(this).attr(\"product\");\r\n            \$(\"#pricing_\" + currency + \"_\" + cycle + \"_\" + product).hide();\r\n            \$(\"#setup_\" + currency + \"_\" + cycle + \"_\" + product).hide();\r\n        });\r\n    });\r\n\r\n    function hidetable(id) {\r\n        \$(\"#trprice\" + id).hide();\r\n        \$(\"#table\" + id).fadeOut();\r\n\r\n    }\r\n    function showtable(recur, id)\r\n    {\r\n\r\n        \$(\"#table\" + id).fadeIn(\"fast\");\r\n        if (recur)\r\n        {\r\n            \$(\"#table\" + id).css(\"max-width\", \"\");\r\n            \$(\"#table\" + id).css(\"margin-left\", \"\");\r\n            \$(\".prod-pricing-recurring\" + id).fadeIn();\r\n        }\r\n        else {\r\n            \$(\".prod-pricing-recurring\" + id).fadeOut(\"fast\", function() {\r\n                \$(\"#table\" + id).css(\"margin-left\", \"29%\");\r\n                \$(\"#table\" + id).css(\"max-width\", \"370px\");\r\n\r\n            });\r\n        }\r\n\r\n    }\r\n</script>\r\n<div id=\"tab_content\" class=\"tab-content admin-tabs\">\r\n    <div class=\"tab-pane active\">\r\n";
    if( isset($msg) && $msg == "success" ) 
    {
        echo "            <div class=\"alert alert-success alert-dismissable\">\r\n                <a href=\"#\" class=\"close\" data-dismiss=\"alert\" aria-label=\"close\">&times;</a>\r\n                <strong>Success!</strong>   ";
        if( $msg == "success" ) 
        {
            echo "Changes made Successfully!";
        }

        echo " </div> \r\n";
    }

    echo "  \r\n           \r\n            <div class=\"row\">\r\n                <div class=\"one\" style=\"width:83%;float:left\">\r\n                    <form action=\"addonmodules.php?module=Easy_WHMCS&page=price\" method=\"POST\" id=\"myform\" style=\"margin-left:15px\">\r\n                ";
    echo "     " . $totalRecords . " Records found, Page " . $currentPage . " of " . $totalPage;
    echo "                        <b style=\"margin-left:50%\">Jump to page:</b>\r\n                        <select name=\"pageno\" >\r\n                ";
    for( $k = 1; $k <= $totalPage; $k++ ) 
    {
        echo "\r\n                                <option value=\"";
        echo $k;
        echo "\" ";
        echo ($currentPage == $k ? "selected" : "");
        echo ">";
        echo $k;
        echo "</option>\r\n    ";
    }
    echo "                            <input type=\"hidden\" name=\"log_limit\" value=\"";
    echo $_REQUEST["log_limit"];
    echo "\">\r\n                            <input type=\"submit\" value=\"Go\">\r\n                        </select>\r\n                    </form></div>\r\n                <div class=\"two\" style=\"margin-right:9px\">\r\n                    <form id=\"change-limit1\" style=\"float: right\" method=\"POST\" action=\"addonmodules.php?module=Easy_WHMCS&page=price\">\r\n\r\n\r\n                        Records <select name=\"log_limit\"style=\"margin-bottom: 10px;\" id=\"easy-limit\">\r\n                            <option value=\"10\" ";
    echo ($limitnum == "10" ? "selected" : "");
    echo ">10</option>\r\n                            <option value=\"20\" ";
    echo ($limitnum == "20" ? "selected" : "");
    echo ">20</option>\r\n\r\n                        </select> per page\r\n\r\n                    </form></div>\r\n            </div>\r\n            <script>\r\n\r\n                \$(\"#easy-limit\").change(function() {\r\n\r\n                    \$(\"#change-limit1\").submit();\r\n\r\n                });\r\n\r\n            </script> \r\n\r\n            <form name=\"price\" method=\"post\" id=\"price\" action=\"addonmodules.php?module=Easy_WHMCS&page=price&action=edit_price\">\r\n                <table class=\"datatable no-margin\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\" width=\"100%\">\r\n                    <thead><tr>\r\n                            <th style=\"width: 27%;\">Product Name</th>\r\n                            <th style=\"width: 25%;\">Type</th>\r\n                            <th style=\"width: 25%;\">Pay Type</th>\r\n\r\n                            <th style=\"width:10%;\" colspan=\"2\">Action</th>\r\n                        </tr></thead>\r\n                    <tbody>\r\n    ";
    $array = Illuminate\Database\Capsule\Manager::table("tblproducts")->join("tblproductgroups", "tblproductgroups.id", "=", "tblproducts.gid")->select("tblproducts.id", "tblproducts.name", "tblproducts.type", "tblproducts.servertype", "tblproducts.paytype", "tblproducts.gid", "tblproductgroups.name as gname")->offset($limitstart)->limit($limitnum)->orderBy("tblproducts.gid", "asc")->get();
    $count = count($array);
    if( isset($array) && !empty($array) ) 
    {
        $activity = $array;
        for( $i = 0; $i < $count; $i++ ) 
        {
            if( $activity[$i]->gname !== $activity[$i - 1]->gname ) 
            {
                echo "                                    <tr> <td  colspan=\"4\" style=\" background-color:#f3f3f3;width:98%\">\r\n                                            <div class=\"prodGroup\" align=\"left\">\r\n\r\n                                                <strong>Group Name:</strong>\r\n                                    ";
                echo $activity[$i]->gname;
                echo "                                            </div>\r\n                                        </td></tr>";
            }

            echo "                                <tr onclick=\"func(this.id)\" style=\"cursor:pointer\" id=\"";
            echo $activity[$i]->id;
            echo "\">\r\n                                    <td style=\"width: 33%;\" align=\"center\">";
            echo $activity[$i]->name;
            echo "</td>\r\n                                    <td style=\"width: 30%;\" align=\"center\">";
            if( $activity[$i]->type == "hostingaccount" ) 
            {
                echo "Hosting Account ";
                if( $activity[$i]->servertype != "" ) 
                {
                    echo "(" . $activity[$i]->servertype . ")";
                }

            }
            else
            {
                if( $activity[$i]->type == "reselleraccount" ) 
                {
                    echo "Reseller Account ";
                    if( $activity[$i]->servertype != "" ) 
                    {
                        echo "(" . $activity[$i]->servertype . ")";
                    }

                }
                else
                {
                    echo "Other Product/services ";
                    if( $activity[$i]->servertype != "" ) 
                    {
                        echo "(" . $activity[$i]->servertype . ")";
                    }

                }

            }

            echo "</td>\r\n                                    <td style=\"width:30%;\" align=\"center\">";
            if( $activity[$i]->paytype == "onetime" ) 
            {
                echo "One Time";
            }
            else
            {
                if( $activity[$i]->paytype == "recurring" ) 
                {
                    echo "Recurring";
                }
                else
                {
                    echo "Free";
                }

            }

            echo "</td>\r\n                                    <td style=\"width:10%;\"><a ><img id=\"arrow";
            echo $activity[$i]->id;
            echo "\" src=\"../modules/addons/Easy_WHMCS/include/down.png\" alt=\"Edit\" height=\"16\" border=\"0\" width=\"16\" style=\"margin-left:33px\"></a></td> \r\n                                </tr> \r\n                                <tr>\r\n                                    <td colspan=4>\r\n                                        <div class=\"outer\" style=\"display:none\" id=\"";
            echo "mydiv" . $activity[$i]->id;
            echo "\">\r\n                                            <div class=\"my_box\" >\r\n\r\n                                                <table style=\"\" id=\"pricingtbl\" class=\"table table-condensed\">\r\n                                        ";
            $results = easy_getCurrency();
            $number = $results["totalresults"];
            $curr = $results["currencies"]["currency"];
            echo "                                                    <tbody>\r\n                                                        <tr><td class=\"fieldlabel\" style=\"border:0\">Payment Type</td>\r\n                                                            <td class=\"fieldarea\" colspan=\"7\" style=\"background-color:#efefef\">\r\n                                                                <label class=\"radio-inline\">\r\n                                                                    <input  name=\"pay";
            echo $activity[$i]->id;
            echo "\"  value=\"free\" ";
            echo ($activity[$i]->paytype == "free" ? "checked" : "");
            echo " onclick=\"hidetable('";
            echo $activity[$i]->id;
            echo "')\" type=\"radio\"> Free</label> \r\n                                                                <label class=\"radio-inline\">\r\n                                                                    <input name=\"pay";
            echo $activity[$i]->id;
            echo "\" value=\"onetime\" ";
            echo ($activity[$i]->paytype == "onetime" ? "checked" : "");
            echo "  onclick=\"showtable(false, '";
            echo $activity[$i]->id;
            echo "')\" type=\"radio\"> One Time</label>\r\n                                                                <label class=\"radio-inline\">\r\n                                                                    <input name=\"pay";
            echo $activity[$i]->id;
            echo "\" value=\"recurring\" ";
            echo ($activity[$i]->paytype == "recurring" ? "checked" : "");
            echo " type=\"radio\" onclick=\"showtable(true, '";
            echo $activity[$i]->id;
            echo "')\"> Recurring</label></td></tr>\r\n\r\n                                                        <tr style=\"height:50px;border:0\" id=\"trprice";
            echo $activity[$i]->id;
            echo "\"><td colspan=\"7\" style=\"border:0\"></td></tr>\r\n\r\n                                                        <tr id='trpricing' style='width:100%;border:0'>\r\n                                                            <td colspan='8' style='border:0'>\r\n                                                                <table id='table";
            echo $activity[$i]->id;
            echo "' width='100%' class=\"jk\">\r\n                                                                    <tbody>\r\n\r\n                                                                        <tr style=\"text-align:center;font-weight:bold;height:40px\" class=\"hh\">\r\n                                                                            <td style=\"background-color:#efefef\">Currency</td>\r\n                                                                            <td style=\"background-color:#efefef\"></td>\r\n                                                                            <td style=\"background-color:#efefef\">One Time/Monthly</td>\r\n                                                                            <td style=\"display: table-cell;background-color:#efefef\" class=\"prod-pricing-recurring";
            echo $activity[$i]->id;
            echo "\">Quarterly</td>\r\n                                                                            <td style=\"display: table-cell;background-color:#efefef\" class=\"prod-pricing-recurring";
            echo $activity[$i]->id;
            echo "\">Semi-Annually</td>\r\n                                                                            <td style=\"display: table-cell;background-color:#efefef\" class=\"prod-pricing-recurring";
            echo $activity[$i]->id;
            echo "\">Annually</td>\r\n                                                                            <td style=\"display: table-cell;background-color:#efefef\" class=\"prod-pricing-recurring";
            echo $activity[$i]->id;
            echo "\">Biennially</td>\r\n                                                                            <td style=\"display: table-cell;background-color:#efefef\" class=\"prod-pricing-recurring";
            echo $activity[$i]->id;
            echo "\">Triennially</td>\r\n                                                                        </tr>\r\n                                                                    <input type=\"hidden\" name=\"number\" class=\"pid\" value=\"";
            echo $number;
            echo "\">\r\n                                                                    <input type=\"hidden\" name=\"pid[]\" class=\"pid\" value=\"";
            echo $activity[$i]->id;
            echo "\">\r\n                                                                    <input type=\"hidden\" id=\"get\" class=\"pid\" value=\"";
            echo $activity[$i]->id;
            echo "\"> \r\n\r\n            ";
            foreach( $curr as $row ) 
            {
                $price = Illuminate\Database\Capsule\Manager::table("tblpricing")->where("relid", "=", $activity[$i]->id)->where("currency", "=", $row["id"])->where("type", "=", "product")->get();
                echo "                                                                        <tr class='hideclass' style=\"text-align:center\" bgcolor=\"#ffffff\">\r\n                                                                            <td rowspan=\"3\" style=\"background-color:#efefef\" class=\"ctd\"><b> ";
                echo $row["code"];
                echo "</b></td>\r\n                                                                            <td>Setup Fee</td>\r\n                                                                            <td><input name=\"currency";
                echo $row["id"];
                echo "[msetupfee][]\" id=\"setup_";
                echo trim($row["code"]);
                echo "_monthly_";
                echo $activity[$i]->id;
                echo "\" value=\"";
                echo $price[0]->msetupfee;
                echo "\"  class=\"form-control input-inline input-100 text-center\" type=\"text\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input name=\"currency";
                echo $row["id"];
                echo "[qsetupfee][]\" id=\"setup_";
                echo trim($row["code"]);
                echo "_quarterly_";
                echo $activity[$i]->id;
                echo "\" value=\"";
                echo $price[0]->qsetupfee;
                echo "\"  class=\"form-control input-inline input-100 text-center\" type=\"text\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input name=\"currency";
                echo $row["id"];
                echo "[ssetupfee][]\" id=\"setup_";
                echo trim($row["code"]);
                echo "_semiannually_";
                echo $activity[$i]->id;
                echo "\" value=\"";
                echo $price[0]->ssetupfee;
                echo "\"  class=\"form-control input-inline input-100 text-center\" type=\"text\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input name=\"currency";
                echo $row["id"];
                echo "[asetupfee][]\" id=\"setup_";
                echo trim($row["code"]);
                echo "_annually_";
                echo $activity[$i]->id;
                echo "\" value=\"";
                echo $price[0]->asetupfee;
                echo "\"  class=\"form-control input-inline input-100 text-center\" type=\"text\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input name=\"currency";
                echo $row["id"];
                echo "[bsetupfee][]\" id=\"setup_";
                echo trim($row["code"]);
                echo "_biennially_";
                echo $activity[$i]->id;
                echo "\"  value=\"";
                echo $price[0]->bsetupfee;
                echo "\"  class=\"form-control input-inline input-100 text-center\" type=\"text\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input name=\"currency";
                echo $row["id"];
                echo "[tsetupfee][]\" id=\"setup_";
                echo trim($row["code"]);
                echo "_triennially_";
                echo $activity[$i]->id;
                echo "\" value=\"";
                echo $price[0]->tsetupfee;
                echo "\"  class=\"form-control input-inline input-100 text-center\" type=\"text\"></td>\r\n                                                                        </tr>\r\n                                                                        <tr class='hideclass'style=\"text-align:center\" bgcolor=\"#ffffff\">\r\n                                                                            <td>Price</td>\r\n                                                                            <td><input name=\"currency";
                echo $row["id"];
                echo "[monthly][]\" id=\"pricing_";
                echo trim($row["code"]);
                echo "_monthly_";
                echo $activity[$i]->id;
                echo "\" size=\"10\"  value=\"";
                echo $price[0]->monthly;
                echo "\" class=\"form-control input-inline input-100 text-center jas\" type=\"text\" ></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input name=\"currency";
                echo $row["id"];
                echo "[quarterly][]\" id=\"pricing_";
                echo trim($row["code"]);
                echo "_quarterly_";
                echo $activity[$i]->id;
                echo "\" size=\"10\"   value=\"";
                echo $price[0]->quarterly;
                echo "\" class=\"form-control input-inline input-100 text-center jas\" type=\"text\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input name=\"currency";
                echo $row["id"];
                echo "[semiannually][]\" id=\"pricing_";
                echo trim($row["code"]);
                echo "_semiannually_";
                echo $activity[$i]->id;
                echo "\" size=\"10\"  value=\"";
                echo $price[0]->semiannually;
                echo "\"  class=\"form-control input-inline input-100 text-center jas\" type=\"text\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input name=\"currency";
                echo $row["id"];
                echo "[annually][]\" id=\"pricing_";
                echo trim($row["code"]);
                echo "_annually_";
                echo $activity[$i]->id;
                echo "\" size=\"10\"  value=\"";
                echo $price[0]->annually;
                echo "\" class=\"form-control input-inline input-100 text-center jas\" type=\"text\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input name=\"currency";
                echo $row["id"];
                echo "[biennially][]\" id=\"pricing_";
                echo trim($row["code"]);
                echo "_biennially_";
                echo $activity[$i]->id;
                echo "\" size=\"10\"   value=\"";
                echo $price[0]->biennially;
                echo "\" class=\"form-control input-inline input-100 text-center jas\" type=\"text\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input name=\"currency";
                echo $row["id"];
                echo "[triennially][]\" id=\"pricing_";
                echo trim($row["code"]);
                echo "_triennially_";
                echo $activity[$i]->id;
                echo "\" size=\"10\"  value=\"";
                echo $price[0]->triennially;
                echo "\" class=\"form-control input-inline input-100 text-center jas\" type=\"text\"></td>\r\n                                                                        </tr>\r\n                                                                        <tr class='hideclass' style=\"text-align:center\" bgcolor=\"#ffffff\">\r\n                                                                            <td>Enable</td>\r\n                                                                            <td><input class=\"pricingtgl\" currency=\"";
                echo trim($row["code"]);
                echo "\" cycle=\"monthly\" type=\"checkbox\" product=\"";
                echo $activity[$i]->id;
                echo "\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input class=\"pricingtgl\" currency=\"";
                echo trim($row["code"]);
                echo "\" cycle=\"quarterly\" type=\"checkbox\" product=\"";
                echo $activity[$i]->id;
                echo "\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input class=\"pricingtgl\" currency=\"";
                echo trim($row["code"]);
                echo "\" cycle=\"semiannually\" type=\"checkbox\" product=\"";
                echo $activity[$i]->id;
                echo "\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input class=\"pricingtgl\" currency=\"";
                echo trim($row["code"]);
                echo "\" cycle=\"annually\" type=\"checkbox\" product=\"";
                echo $activity[$i]->id;
                echo "\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input class=\"pricingtgl\" currency=\"";
                echo trim($row["code"]);
                echo "\" cycle=\"biennially\" type=\"checkbox\" product=\"";
                echo $activity[$i]->id;
                echo "\"></td>\r\n                                                                            <td style=\"display: table-cell;\" class=\"prod-pricing-recurring";
                echo $activity[$i]->id;
                echo "\"><input class=\"pricingtgl\" currency=\"";
                echo trim($row["code"]);
                echo "\" cycle=\"triennially\" type=\"checkbox\" product=\"";
                echo $activity[$i]->id;
                echo "\"></td>\r\n                                                                        </tr>\r\n            ";
            }
            echo "                                                    </tbody>\r\n                                                </table>\r\n\r\n                                                </td>\r\n                                                </tr>\r\n                                                </tbody>\r\n                                                </table>\r\n                                            </div>\r\n                                        </div>\r\n                                    </td>\r\n                                </tr>\r\n                          ";
        }
    }

    echo "</tbody>\r\n                </table>  \r\n                <p align=\"center\">\r\n                        ";
    if( isset($previousPage) && !empty($previousPage) && $previousPage != 0 ) 
    {
        echo "                        <a href=\"addonmodules.php?module=Easy_WHMCS&page=price&log_limit=";
        echo $_REQUEST["log_limit"];
        echo "&pageno=";
        echo $previousPage;
        echo "\">« Previous Page </a>&nbsp; \r\n        ";
    }
    else
    {
        echo "« Previous Page &nbsp;";
    }

    echo "    ";
    if( isset($nextPage) && !empty($nextPage) && $totalPage >= $nextPage ) 
    {
        echo " <a href=\"addonmodules.php?module=Easy_WHMCS&page=price&log_limit=";
        echo $_REQUEST["log_limit"];
        echo "&pageno=";
        echo $nextPage;
        echo "\">Next Page » </a>&nbsp; \r\n                        ";
    }
    else
    {
        echo "Next Page » &nbsp;";
    }

    echo "\r\n            </p>  \r\n            <p align=\"left\">With Selected:<input type=\"submit\" style=\"margin-left:20px;\" name=\"edit_price\"  class=\"btn btn-success\" value=\"Save Changes\"/></p>\r\n        </form>\r\n    </div>\r\n</div>\r\n<style>\r\n    .my_box{\r\n\r\n\r\n        width:70%;\r\n        margin-left:15%;\r\n    }\r\n    .outer\r\n    {\r\n\r\n        display:none;\r\n        border: 3px solid #E2E7E9;\r\n        padding:10px;\r\n    }\r\n    .fieldlabel\r\n    {\r\n        background-color: #fff;\r\n        text-align: left;\r\n    }\r\n    .fieldarea {\r\n        background-color: #efefef;\r\n        text-align: left;\r\n    }\r\n    .radio-inline {\r\n        position: relative;\r\n        display: inline-block;\r\n        padding-left: 20px;\r\n        margin-bottom: 0;\r\n        font-weight: 400;\r\n        vertical-align: middle;\r\n        cursor: pointer;\r\n    }\r\n\r\n    table.datatable tr:hover td {\r\n        background-color: transparent !important;\r\n    }\r\n    table.datatable tr:hover .table td.fieldarea {\r\n        background-color: #efefef !important;\r\n    }\r\n    table.datatable tr:hover .table tr.hh {\r\n        background-color: #efefef !important;\r\n    }\r\n    table.datatable tr:hover .table .jk td.ctd {\r\n        background-color: #efefef !important;\r\n    }\r\n</style>\r\n";
}
else
{
    echo $filename . " is missing. Please upload the module properly or contact us.";
    exit();
}


